/*
 * indicator-network - user interface for connman
 * Copyright 2010-2011 Canonical Ltd.
 *
 * Authors:
 * Andrew Higginson
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 3, as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranties of
 * MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

public class Device : GLib.Object {
    
    public DeviceType type_ { get; set; }
    public DeviceState state { get; set; }
    
    public Device() {
    }
}

public static Device[] get_wired_devices() {
    // Populate Device View (temporary)
    var device1 = new Device();
    device1.type_ = DeviceType.WIRED;
    device1.state = DeviceState.OFFLINE;
    //
    return {device1};
}
    
public static Device[] get_wireless_devices() {
    // Populate Device View (temporary)
    var device1 = new Device();
    device1.type_ = DeviceType.WIRELESS;
    device1.state = DeviceState.ONLINE;
    var device2 = new Device();
    device2.type_ = DeviceType.WIRELESS;
    device2.state = DeviceState.OFF;
    //
    return {device1, device2};
}
    
public static Device[] get_mobile_devices() {
    // Populate Device View (temporary)
    var device3 = new Device();
    device3.type_ = DeviceType.MOBILE;
    device3.state = DeviceState.CONNECTED;
    //
    return {device3};
}    
    
public static Device[] get_bluetooth_devices() {
    // Populate Device View (temporary)
    var device4 = new Device();
    device4.type_ = DeviceType.BLUETOOTH;
    device4.state = DeviceState.OFF;
    //
    return {device4};
}

public static Device get_flightmode_device() {
    var device = new Device();
    device.type_ = DeviceType.FLIGHTMODE;
    device.state = DeviceState.OFF;
    return device;
}
